/*
 * $LastChangedRevision: 3952 $
 * $LastChangedDate:: 2025-11-27 21:04:55 +0100#$
 *
 * This file is part of X2C. web: x2c.lcm.at
 *
 * Copyright (c) 2016, Linz Center of Mechatronics GmbH (LCM), web: x2c.lcm.at
 * All rights reserved.
 */
/*
 * This file is licensed according to the BSD 3-clause license as follows:
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the "Linz Center of Mechatronics GmbH" and "LCM" nor
 *       the names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL "Linz Center of Mechatronics GmbH" BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include <asf.h>
#include "LNet.h"
#include "Services.h"
#include "BlockServices.h"
#include "ServicesModelIdentifier.h"
#include "SerialGeneric.h"
#include "TableStruct.h"
#include "Hardware.h"
#include "X2C.h"
#include "Main.h"

/* X2C maintenance structure */
volatile tTableStruct TheTableStruct;
volatile tTableStruct* TableStruct = &TheTableStruct;

/* LNet protocol buffersize & node identifier */
#define LNET_BUFFERSIZE ((uint16)255)
#define LNET_NODEID ((uint8)1)

static tSerial hwInterface;
static tLNet protocol;
static uint8 protocolBuffer[LNET_BUFFERSIZE];

/* used by init version info */
const struct {
	uint8 date[11];
	uint8 time[8];
} compilationDate = { __DATE__, __TIME__ };
	
/* private prototypes */
static void initVersionInfo(volatile tTableStruct* tblStruct, uint16 appVersion);

/** 
 * @brief Main function.
 * 
 * @return The main function will never return due to the never ending loop.
 */
int main(void)
{
	/** - initialize system clock */
	sysclk_init();
	
	/** - initialize board */
	board_init();
	
	/** - initialize "integrated bootloader":
     *    - configuration of LNet protocol:
     *      - Node-ID: 1
     *      - Buffer size: 255
     *      .
     *    .
     *  - initialize serial interface
     */
	initTableStruct();
	initSerialGeneric(&hwInterface);
	initSerial(&hwInterface);
	initLNet(&protocol, protocolBuffer, LNET_BUFFERSIZE, LNET_NODEID);
	initServiceTable((tProtocol*)&protocol);
	addCoreServices((tProtocol*)&protocol);
	addBlockServices((tProtocol*)&protocol);
	addModelIdentifierServices((tProtocol*)&protocol);
	addTableStructProtocol((tProtocol*)&protocol);
	linkSerial((tProtocol*)&protocol, &hwInterface);
	TableStruct->DSPState = PRG_LOADED_STATE;
	
	initVersionInfo(TableStruct, (uint16)0x0001);
	
	/** - initialize X2C */
	X2C_Init();
	resetWatchdog();
	
	/** - initialize hardware */
	initHardware();
	resetWatchdog();

	/** - never ending loop -> interrupt driven algorithm */
	while (1)
	{
		/* serial communication with X2C communicator */		
		protocol.communicate((tProtocol*)&protocol);
	}
}



/** 
 * @brief Main control task.
 * 
 * Calling rate = 100us
 */
void mainTask(void)
{
	/** - assign inports (not available in this demo) */
	
	/** - update X2C */
	X2C_Update();
	
	/** - update outports */
	if (*x2cModel.outports.bLED > 0)
	{
		BLINKY_LED_ON;
	}
	else
	{
		BLINKY_LED_OFF;
	}
	
	resetWatchdog();
}

/**
 * @brief Routine to set version.
 *
 *				Adds frame compilation date, time and version info to X2C maintenance structure.
 * 
 * @param tblStruct X2C maintenance structure.
 * @param appVersion Version number.
 */
static void initVersionInfo(volatile tTableStruct* tblStruct, uint16 appVersion)
{
	tblStruct->framePrgVersion = appVersion;
	tblStruct->framePrgCompDateTime = (uint8*)&compilationDate;
}
